SUBROUTINE Expand(List,Idx,Dim)

  ! This subroutine expands a list entered in a compacted form
  ! ie 1 -10 => 1 2 3  4 5 6 7 8 9 10

!----------------------------------------------------------------------
!  Copyright 2003-2014 Ecole Normale Supérieure de Lyon, 
!  Centre National de la Recherche Scientifique,
!  Université Claude Bernard Lyon 1. All rights reserved.
!
!  This work is registered with the Agency for the Protection of Programs 
!  as IDDN.FR.001.100009.000.S.P.2014.000.30625
!
!  Authors: P. Fleurat-Lessard, P. Dayal
!  Contact: optnpath@gmail.com
!
! This file is part of "Opt'n Path".
!
!  "Opt'n Path" is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Affero General Public License as
!  published by the Free Software Foundation, either version 3 of the License,
!  or (at your option) any later version.
!
!  "Opt'n Path" is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Affero General Public License for more details.
!
!  You should have received a copy of the GNU Affero General Public License
!  along with "Opt'n Path". If not, see <http://www.gnu.org/licenses/>.
!
! Contact The Office of Technology Licensing, valorisation@ens-lyon.fr,
! for commercial licensing opportunities.
!----------------------------------------------------------------------

  use VarTypes

  INTEGER(KINT), INTENT(IN) :: Dim
  INTEGER(KINT), INTENT(INOUT) :: List(Dim)
  INTEGER(KINT), INTENT(INOUT) :: Idx

  LOGICAL, ALLOCATABLE :: FTmp(:) ! Dim
  LOGICAL :: Debug
  INTEGER(KINT) :: i

  INTERFACE
     function valid(string) result (isValid)
       CHARACTER(*), intent(in) :: string
       logical                  :: isValid
     END function VALID

  END INTERFACE

  Debug=valid('Expand')

  Allocate(FTmp(Dim))
  FTmp=.FALSE.

  Idx=1

  DO WHILE (List(Idx).NE.0)
     If (List(Idx).LT.0) THEN
        DO I=List(Idx-1),abs(List(Idx))
           IF (.NOT.FTmp(I)) THEN
              FTmp(I)=.TRUE.
           END IF
        END DO
     ELSEIF (.NOT.FTmp(List(Idx))) THEN
        FTmp(List(Idx))=.TRUE.
     END IF
     Idx=Idx+1
  END DO

  if (debug) WRITE(*,*) "DBG Expand,  List",List

  ! We convert List into non compacted form
  Idx=1
  DO I=1,Dim
     If(Ftmp(I)) THEN
        List(Idx)=I
        Idx=Idx+1
     END IF
  END DO
  List(Idx)=0
  Idx=Idx-1

 DEALLOCATE(Ftmp)

END SUBROUTINE Expand
